import {
  Modal,
  ModalService,
  LoadingService,
  GridEditable,
} from '@zeedhi/common';
import {
  Metadata,
  IEventParam,
  Http,
} from '@zeedhi/core';
import {
  TekGrid,
} from '@zeedhi/teknisa-components-common';
import { Utilities } from '@/util/Utilities';

export class DetailsItemOperationalModalController {
  private detailsItemOperationalModal!: Modal;
  
  public rowsEditableDetail = [];
  
  public currentRowDetail = {} as any;
  
  public isNotUpdateRowEditing = true;
  
  /* public async createDetailsItemOperationalModal() {
    this.detailsItemOperationalModal = await ModalService.createFromJson('/modals/detailsItemOperationalModal', true);
  } */
  
  public destroyDetailsItemOperationalModal() {
    this.detailsItemOperationalModal?.destroy();
  }
  
  public async openDetailsItemOperationalModal({ row }) {
    /* const filter = {
      CDFILIAL: row.CDFILIAL,
      NRPERCENTUAL: row.NRSEQUENCIAL,
      ORIGEM: row.DSORIGEM,
      CDDESPPREV: row.CDCODIGO,
    }; */
    this.currentRowDetail = row;
    this.detailsItemOperationalModal = await ModalService.createFromJson('/modals/detailsItemOperationalModal', true);
    await this.detailsItemOperationalModal.show();
    /* const gridDetailModal = Metadata.getInstance<TekGrid>('gridDetailsItemOperational');
    gridDetailModal.datasource.setFilter(filter); */
  }
  
  public closeDetailsItemOperationalModal() {
    this.detailsItemOperationalModal.hide();
  }
  
  get setRouteDetailModal() {
    const currentRow = this.currentRowDetail;
    const routeDescription = [
      {
        ORIGIN: 'DESPESA',
        route: '/crudN/detailExpense',
        params: {
          CDDESPPREV: currentRow.CDCODIGO,
          NRPERCENTUAL: currentRow.NRSEQUENCIAL,
          ORIGEM: 'DESPESA',
          CDFILIAL: currentRow.CDFILIAL,
        },
      },
      {
        ORIGIN: 'ORCAMENTOMO',
        route: '/crudN/detailLabor',
        params: {
          NRPERCENTUAL: currentRow.NRSEQUENCIAL,
          CDORCAMENTOMO: currentRow.CDCODIGO,
          ORIGEM: 'ORCAMENTOMO',
          CDFILIAL: currentRow.CDFILIAL,
        },
      },
    ];
    const result = routeDescription.filter((item) => item.ORIGIN === currentRow.DSORIGEM);
    const route = result[0].route;
    const params = result[0].params;
    return {
      route,
      uniqueKey: 'NRSEQ',
      type: 'rest',
      limit: 10,
      lazyLoad: false,
      filter: params,
    };
  }
  
  /* public setRouteDescriptionDetail({ row, component }) {
    const type = component ? component.value : row.TIPO;
    const routeDescription = [
      // PRODUTO
      {
        TYPE: 'PRODUTO', route: '/crudN/descriptionProductDetail', params: {},
      },
      // CONTA CONTABIL
      {
        TYPE: 'CONTABIL', route: '/crudN/descriptionAccountDetail', params: {},
      },
      // CONTA A PAGAR
      {
        TYPE: 'TCPAGAR', route: '/crudN/descriptionBillsToPayDetail', params: {},
      },
    ];
    const result = routeDescription.filter((item) => item.TYPE === type);
    const route = result.length > 0 ? result[0].route : '';
    const params = result.length > 0 ? result[0].params : {};
    if (component) {
      const gridDetail = Metadata.getInstance<TekGrid>('detailsOperationalItems');
      const fieldDescription = gridDetail.getComponent(row.NRSEQUENCIAL, 'DSDESCRICAO');
      (fieldDescription as any).datasource.route = route;
      (fieldDescription as any).datasource.filter = params;
    }
    return {
      route,
      uniqueKey: 'CODIGOARV',
      type: 'rest',
      limit: 10,
      lazyLoad: true,
      filter: params,
    };
  } */
  
  /* public addNewRow({ component }: IEventParam<TekGrid>) {
    const newId = (component.datasource.total + 1).toString();
    this.rowsEditableDetail.push(newId);
    component.addNewRow({ NRSEQ: newId }, 'start');
    const nameInput = Metadata.getInstance<Select>(`TIPO_editable_${newId}`);
    nameInput.setFocus();
  } */
  
  public editableType({ row }) {
    const newRow = this.rowsEditableDetail.indexOf(row.NRSEQ) !== -1;
    return newRow;
  }
  
  public onInlineEditUpdateRow({ component }: IEventParam<GridEditable>) {
    this.isNotUpdateRowEditing = !component.editing;
  }
  
  public updateDetailModal({ component, event }: IEventParam<TekGrid>) {
    event.preventDefault();
    const gridDetail = Metadata.getInstance<TekGrid>('detailsOperationalItems');
    const utilities = new Utilities();
    const editedRows = component.getEditedRows();
    const currentRowGridDetail = gridDetail.datasource.currentRow;
    const data = [editedRows, currentRowGridDetail];
    LoadingService.show();
    Http.post('/updateDetailModal', {
      requestType: 'DataSet',
      dataset: data,
    }).then(async () => {
      await component.saveEditedRows();
      this.onInlineEditUpdateRow({ component });
      LoadingService.hide();
      utilities.successMessage();
    }).catch((e) => {
      utilities.errorMessage();
      LoadingService.hide();
      console.warn(e);
    });
  }
}
