import {
  Modal,
  ModalService,
  SelectMultiple,
  Form,
} from '@zeedhi/common';
import {
  Http,
  Metadata,
} from '@zeedhi/core';

export class RegisterOperatingParamsModalController {
  private registerOperatingParamsModal!: Modal;
  
  public async createRegisterOperatingParamsModal() {
    this.registerOperatingParamsModal = await ModalService.createFromJson('/modals/registerOperatingParamsModal', true);
  }
  
  public destroyRegisterOperatinsParamsModal() {
    this.registerOperatingParamsModal?.destroy();
  }
  
  public openRegisterOperatingParamsModal() {
    this.registerOperatingParamsModal.show();
  }
  
  public closeRegisterOperatingParamsModal() {
    this.registerOperatingParamsModal.hide();
  }
  
  public populateOpBudgetParamsRegister() {
    const registerSelect = Metadata.getInstance<SelectMultiple>('RegisterUnitMultipleSelect');
    Http.get('/populateOpBudgetParamsGrid').then((response) => {
      const data = response.data.dataset.populateOpBudgetParamsGrid;
      registerSelect.datasource.updateData(data);
    });
  }
  
  public saveOpBudgetParamsRegister() {
    const registerForm = Metadata.getInstance<Form>('registerUnitForm');
    if (
      registerForm.value.contractReadjustmentMonth != null
      && registerForm.value.budgetStartDay != null
      && registerForm.value.RegisterUnitMultipleSelect != null
    ) {
      const sendObject = {
        NRMESREAJCONTR: registerForm.value.contractReadjustmentMonth,
        VRPEORCBLOQFIL: registerForm.value.blockLimitRegister,
        VRPEORCALERTFIL: registerForm.value.limitAlertNumber,
        IDCALCOMESTORC: registerForm.value.budgetBaseCalculation,
        NRDIAINIORCAGOP: registerForm.value.budgetStartDay,
        IDCONSAFORCFIL: registerForm.value.ConsistentAFSelect,
        CDFILIAL: registerForm.value.RegisterUnitMultipleSelect,
      };
      Http.post('/saveOpBudgetParamsRegister', {
        requestType: 'Row',
        row: sendObject,
      });
      this.registerOperatingParamsModal.hide();
    } else {
      registerForm.validate();
    }
  }
}
